/* Amiga processes, half-hearted simulation of unix processes & signals */
int getpid(void);		/* Returns Emacs's pid, a constant */
void kill(int pid, int signal);	/* Try and signal given process with given signal */
void (*signal(int sig,void (*fn)(int)))(int); /* Setup signal handler */
int wait_for_terminatiob(int pid); /* Wait for process pid to terminate */
int wait_without_blocking(void); /* Wait for any process to terminate */
/* Execute given program with arguments & values for input, output & error */
/* Seems rather unstable */
int exec(char *program, char **argv, int input, int output, char *dir);
int init_amiga_processes(void);
void cleanup_amiga_processes(void);

/* Signal mask to wait on to implement unix alarm signal */
/* Call check_alarm() when it appears */
extern unsigned long alarmsig;
void check_alarm(void);

/* Prototypes for functions defined in amiga_clipboard.c */
int Famiga_cut(int arg);
int Famiga_paste(void);
void syms_of_amiga_clipboard(void);
int init_clipboard(void);
void cleanup_clipboard(void);
void cleanup_amiga_menu(void);

/* amiga_menu.c */
int init_amiga_menu(void);
void syms_of_amiga_menu(void);
void suspend_menus(void);
void resume_menus(void);

/* amiga_screen.c */
extern struct Window *emacs_win;
void get_window_size (int *widthp, int *heightp);
void check_window(int force);
void screen_putc(int toput);
void screen_puts(char *strtoput, unsigned int len);
void syms_of_amiga_screen(void);
int init_amiga_screen(void);
void cleanup_amiga_screen(void);

/* amiga_serial.c */
int init_amiga_serial(void);
void cleanup_amiga_serial(void);
void check_serial(int force);
void serial_putc(int c);
void serial_puts(char *c, int len);
unsigned long serial_baud_rate(void);

/* amiga_sysdep.c */
#define MALLOC_HUNK_SIZE 87000 /* Default malloc hunk size */
extern long malloc_hunk_size; /* Amount of memory malloc'ed by a to-be-dumped emacs */
extern long far pre_alloc; /* Amount of memory to reserve for emacs */

/* Various special values used to find the beginning & end of the text, data,
   bss and malloc segments. */
extern int first_data, last_data, first_bss, last_bss;
extern void first_function(), last_function();
extern char *malloc_hunk;
extern int amiga_initialized;	/* True once Emacs has been undumped or initialised */
struct mem_header		/* sizeof() must be multiple of 4 ! */
{
    struct mem_header *next, *prev;
    long size;
    /* Data follows */
};
extern struct mem_header *free_list;
void *alloc_sys(long memsize);

void print_mem(void);
char *getwd(char *pathname);
char *mktemp(char *name);
int pipe(int *fd);
int convert_oserr(int ioerr);
int link(char *from, char *to);
void make_environ(void);
int set_exclusive_use(int fd);
int wait_without_blocking(void);
int wait_for_termination(int pid);
int setpgrp_of_tty(int pid);
int sys_suspend(void);
int init_sigio(void);
int reset_sigio(void);
int request_sigio(void);
int unrequest_sigio(void);
int init_sys_modes(void);
int tabs_safe_p(void);
int reset_sys_modes(void);
char *get_system_name(void);
int select_alarm(void);
int select(int nfds, int *rfds, int *wfds, int *efds, int *timeout);
int croak(char *badfunc);
char *getenv(char *varname);
struct IORequest *device_open(char *name, unsigned long unit, unsigned long flags,
			      void *data, unsigned long data_len, int req_size);
void device_close(struct IORequest *ioreq);
void cleanup_amiga(void);
void init_amiga(void);
#define AMIGASEQ '\034' /* ^\ Is the Amiga sequence introducer */

/* Signal mask used to detect available keyboard input.
   Must be set by amiga_serial or amiga_screen */
extern unsigned long inputsig;
extern int sleeping;		/* True if in sleep or sleep_or_input */

/* Prototypes for functions defined in amiga_tty.c */
int get_screen_size(int *widthp,
                    int *heightp);
int init_baud_rate(void);
void check_intuition(void);
void enque(unsigned char toque,
           int meta);
void amiga_consume_input(int force);
void amiga_wait_for_input(void);
int discard_tty_input(void);
void cputc(int toput);
void cputs(char *strtoput,
           unsigned int len);
void sleep_or_input(int secs);
void syms_of_amiga_tty(void);
int init_amiga_tty(void);
void cleanup_amiga_tty(void);

/* amiga_dump.c */
extern void *far first_fn, *far last_fn;
